#pragma once

#include "ofMain.h"
#include "ofxMaxim.h"
#include "ofxGui.h"

class ofApp : public ofBaseApp{
    
public:
    void setup();
    void update();
    void draw();
    void audioOut(float * output, int bufferSize, int nChannels);
    void drawWaveform();
    void keyPressed(int key);
    void randomizeParams();
    
    int sampleRate, bufferSize;
    
    maxiOsc carrier, mod,mod2;
    maxiFilter lowpass;
    
    ofxPanel gui;
    ofParameter<float> carrierFreq, modFreq, modIndex, gain, cutoff,resonance,modFreq2,modIndex2;
    
    double oscOUT, modOUT, mix,filterOUT,modOUT2;
    
    // used for drawing waveform
    float soundBuffer[512], pauseBuffer[512];
    
    bool pause;
};

